
package zoomagazin;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;


public class AdminArea extends javax.swing.JFrame {
    private UserManager manager;
	private Catalogue catalogue;
	
	private final String fileUsers = "users";
	private final String fileProducts = "products";

    /** Creates new form AdminArea */
    public AdminArea() {
        initComponents();
        manager = new UserManager();
		catalogue = new Catalogue();

        try{
            manager.openDataBase(fileUsers);
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "User repository was not opened. Repo file = '" + fileUsers + "'. ", "Error repo open" );
			return;
        }

        try{
			catalogue.openDataBase(fileProducts);
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "Products repository was not opened. Repo file = '" + fileProducts + "'. ", "Error repo open" );
			return;
        }

		showRepository();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txtUsername = new javax.swing.JTextField();
        txtPassword = new javax.swing.JTextField();
        btnInsertUser = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtareaUsers = new javax.swing.JTextArea();
        btnOpenDatabase = new javax.swing.JButton();
        btnSaveDatabase = new javax.swing.JButton();
        btnAddDatabase = new javax.swing.JButton();
        txtFileName = new javax.swing.JTextField();
        btnClearRepo = new javax.swing.JButton();
        txtUserType = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        txtProductName = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        txtProductDescription = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        txtProductManufacturer = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        txtProductType = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        txtProductPrice = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        txtProductVipPrice = new javax.swing.JTextField();
        txtProductQuantity = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtareaProducts = new javax.swing.JTextArea();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        txtRemoveProductId = new javax.swing.JTextField();
        btnRemoveProduct = new javax.swing.JButton();
        jLabel14 = new javax.swing.JLabel();
        txtRemoveUserId = new javax.swing.JTextField();
        btnRemoveUser = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        btnInsertUser.setText("Enter");
        btnInsertUser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnInsertUserActionPerformed(evt);
            }
        });

        txtareaUsers.setColumns(20);
        txtareaUsers.setRows(5);
        jScrollPane1.setViewportView(txtareaUsers);

        btnOpenDatabase.setText("Open File");
        btnOpenDatabase.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOpenDatabaseActionPerformed(evt);
            }
        });

        btnSaveDatabase.setText("Save File");
        btnSaveDatabase.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveDatabaseActionPerformed(evt);
            }
        });

        btnAddDatabase.setText("Add File");
        btnAddDatabase.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddDatabaseActionPerformed(evt);
            }
        });

        btnClearRepo.setText("Clear Repository");
        btnClearRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearRepoActionPerformed(evt);
            }
        });

        jLabel1.setText("Username :");

        jLabel2.setText("Password :");

        jLabel3.setText("UserType :");

        jLabel4.setText("Name :");

        jLabel5.setText("Description :");

        txtProductDescription.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtProductDescriptionActionPerformed(evt);
            }
        });

        jLabel6.setText("Manufacturer :");

        jLabel7.setText("Product type :");

        txtProductType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtProductTypeActionPerformed(evt);
            }
        });

        jLabel8.setText("Quantity :");

        jLabel9.setText("Price :");

        jLabel10.setText("Vip price :");

        jButton1.setText("Add Product");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        txtareaProducts.setColumns(20);
        txtareaProducts.setRows(5);
        jScrollPane2.setViewportView(txtareaProducts);

        jLabel11.setText("UserManager");

        jLabel12.setText("Products");

        jLabel13.setText("ID :");

        txtRemoveProductId.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtRemoveProductIdActionPerformed(evt);
            }
        });

        btnRemoveProduct.setText("Remove");
        btnRemoveProduct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveProductActionPerformed(evt);
            }
        });

        jLabel14.setText("ID :");

        btnRemoveUser.setText("Remove");
        btnRemoveUser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveUserActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(134, 134, 134)
                .addComponent(jLabel11)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 357, Short.MAX_VALUE)
                .addComponent(jLabel12)
                .addGap(313, 313, 313))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(6, 6, 6)
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 398, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel2)
                                            .addComponent(jLabel1)
                                            .addComponent(jLabel3))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 166, Short.MAX_VALUE)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(txtUsername, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addGroup(layout.createSequentialGroup()
                                                .addComponent(txtUserType, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addComponent(btnInsertUser))))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel14)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(txtRemoveUserId, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(btnRemoveUser)))))
                        .addGap(41, 41, 41))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(btnOpenDatabase, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnSaveDatabase, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnAddDatabase, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtFileName, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnClearRepo)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5)
                            .addComponent(jLabel6)
                            .addComponent(jLabel7)
                            .addComponent(jLabel8)
                            .addComponent(jLabel9)
                            .addComponent(jLabel10))
                        .addGap(34, 34, 34)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtProductQuantity)
                            .addComponent(txtProductDescription, javax.swing.GroupLayout.DEFAULT_SIZE, 219, Short.MAX_VALUE)
                            .addComponent(txtProductName)
                            .addComponent(txtProductManufacturer)
                            .addComponent(txtProductType)
                            .addComponent(txtProductPrice)
                            .addComponent(txtProductVipPrice, javax.swing.GroupLayout.DEFAULT_SIZE, 219, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jButton1)
                        .addGap(57, 57, 57)
                        .addComponent(jLabel13)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtRemoveProductId, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnRemoveProduct, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(85, 85, 85))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(jLabel12))
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 251, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(txtUserType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(btnInsertUser)))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel3)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnRemoveUser)
                            .addComponent(txtRemoveUserId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel14))
                        .addGap(42, 42, 42)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnOpenDatabase)
                            .addComponent(btnSaveDatabase)
                            .addComponent(btnAddDatabase))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtFileName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btnClearRepo)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtProductName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtProductDescription, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6)
                            .addComponent(txtProductManufacturer, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel7)
                            .addComponent(txtProductType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(35, 35, 35)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel8)
                            .addComponent(txtProductQuantity, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel9)
                            .addComponent(txtProductPrice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel10)
                            .addComponent(txtProductVipPrice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton1)
                            .addComponent(btnRemoveProduct)
                            .addComponent(jLabel13)
                            .addComponent(txtRemoveProductId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(129, 129, 129))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnInsertUserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnInsertUserActionPerformed
        try{
            manager.insertUser( createUser() );
            showRepository();
        }
        catch( Exception ex ){
            // Nothing was added.
            logError( ex, "User was not inserted. ", "Error user insert" );
            return;
        }
    }//GEN-LAST:event_btnInsertUserActionPerformed

    private void btnSaveDatabaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveDatabaseActionPerformed
        try{
            String file = txtFileName.getText();
            manager.saveDataBase( file );
        }
        catch( Exception ex ){
            // Nothing was saved.
            logError( ex, "User repository was not saved. ", "Error repo save" );
            return;
        }
    }//GEN-LAST:event_btnSaveDatabaseActionPerformed

    private void btnOpenDatabaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOpenDatabaseActionPerformed
        if( 0 != manager.size() &&
                0 != JOptionPane.showConfirmDialog( this, "Are you sure to delete all users?" ) ) return;

        try{
            String file = txtFileName.getText();
            manager.openDataBase( file );
            showRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "Question repository was not opened. ", "Error repo open" );
            return;
        }
    }//GEN-LAST:event_btnOpenDatabaseActionPerformed

    private void btnAddDatabaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddDatabaseActionPerformed
        try{
            String file = txtFileName.getText();
            manager.addDataBase( file );
            showRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "User repository was not opened. ", "Error repo open" );
            return;
        }
    }//GEN-LAST:event_btnAddDatabaseActionPerformed

    private void btnClearRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearRepoActionPerformed
        if( 0 == manager.size() ||
                0 != JOptionPane.showConfirmDialog( this, "Are you sure to delete all users?" ) ) return;

        manager.clearRepository();
        showRepository();
    }//GEN-LAST:event_btnClearRepoActionPerformed

	private void txtProductDescriptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtProductDescriptionActionPerformed
		// TODO add your handling code here:
}//GEN-LAST:event_txtProductDescriptionActionPerformed

	private void txtProductTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtProductTypeActionPerformed
		// TODO add your handling code here:
}//GEN-LAST:event_txtProductTypeActionPerformed

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		try {
			ProductSpec spec = new ProductSpec(txtProductName.getText(),
					Integer.parseInt(txtProductDescription.getText()),
					new Manufacturer(txtProductManufacturer.getText()),
					new ProductType(txtProductType.getText()));
			catalogue.addProduct( Integer.parseInt(txtProductQuantity.getText()),
					Integer.parseInt(txtProductPrice.getText()),
					Integer.parseInt(txtProductVipPrice.getText()),
					spec );
			catalogue.saveDataBase(fileProducts);
		} catch (ZooException ex) {
            logError( ex, "Zoo Exception: ", "Error adding product" );
		} catch (Exception ex) {
            logError( ex, "Exception: ", "Error adding product" );
		}

		showRepository();
	}//GEN-LAST:event_jButton1ActionPerformed

	private void txtRemoveProductIdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtRemoveProductIdActionPerformed
		// TODO add your handling code here:
}//GEN-LAST:event_txtRemoveProductIdActionPerformed

	private void btnRemoveProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveProductActionPerformed
		int id = Integer.parseInt( txtRemoveProductId.getText() ) - 1;
		try {
			catalogue.removeProduct(id);
			catalogue.saveDataBase(fileProducts);
		} catch (ZooException ex) {
			logError( ex, "Zoo Exception: ", "Error Removing product" );
		}

		showRepository();
}//GEN-LAST:event_btnRemoveProductActionPerformed

	private void btnRemoveUserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveUserActionPerformed
		int id = Integer.parseInt( txtRemoveUserId.getText() ) - 1;
		try {
			manager.removeUser(id);
			manager.saveDataBase(fileUsers);
		} catch (ZooException ex) {
			logError( ex, "Zoo Exception: ", "Error Removing user" );
		}

		showRepository();
}//GEN-LAST:event_btnRemoveUserActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AdminArea().setVisible(true);
            }
        });
    }


    // Private
    //
    private User createUser() throws ZooException{
        String username = txtUsername.getText();
        String password = txtPassword.getText();
		int userType = Integer.parseInt(txtUserType.getText());
        clearUserFields();

        return new User( username, password, userType );
    }

    private void showRepository(){
        txtareaUsers.setText( manager.toString() );
		txtareaProducts.setText( catalogue.toString() );
    }

    private void clearUserFields(){
        txtUsername.setText( "" );
        txtPassword.setText( "" );
        txtUserType.setText( "" );
    }

    private static void logError( Exception ex, String reason, String title ){
        ex.printStackTrace();
        System.out.println();
        JOptionPane.showMessageDialog( null, reason + ex.getMessage(),
                title, JOptionPane.WARNING_MESSAGE );
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddDatabase;
    private javax.swing.JButton btnClearRepo;
    private javax.swing.JButton btnInsertUser;
    private javax.swing.JButton btnOpenDatabase;
    private javax.swing.JButton btnRemoveProduct;
    private javax.swing.JButton btnRemoveUser;
    private javax.swing.JButton btnSaveDatabase;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField txtFileName;
    private javax.swing.JTextField txtPassword;
    private javax.swing.JTextField txtProductDescription;
    private javax.swing.JTextField txtProductManufacturer;
    private javax.swing.JTextField txtProductName;
    private javax.swing.JTextField txtProductPrice;
    private javax.swing.JTextField txtProductQuantity;
    private javax.swing.JTextField txtProductType;
    private javax.swing.JTextField txtProductVipPrice;
    private javax.swing.JTextField txtRemoveProductId;
    private javax.swing.JTextField txtRemoveUserId;
    private javax.swing.JTextField txtUserType;
    private javax.swing.JTextField txtUsername;
    private javax.swing.JTextArea txtareaProducts;
    private javax.swing.JTextArea txtareaUsers;
    // End of variables declaration//GEN-END:variables

}
