
package zoomagazin;
import java.io.Serializable;


public class ProductSpec implements Serializable {

    String name;
    int description;
    Manufacturer manufacturer;
    ProductType type;


    public ProductSpec( String name, int description, Manufacturer manufacturer,
            ProductType productType ) throws ZooException{
        setName( name );
        setDescription( description );
        setManufacturer( manufacturer );
        setProductType( productType );
    }

    public void setName( String name ) throws ZooException{
        if( name == null || name.equals("") ) throw new ZooException("Empty Product Name");
        this.name = name;
    }

    public void setDescription( int description ) throws ZooException{
        if( description < 0 ) throw new ZooException("Invalid Product Description");
        this.description = description;
    }

    public void setManufacturer( Manufacturer manufacturer ) throws ZooException{
        if( manufacturer == null ) throw new ZooException("Empty Product Manufacturer");
        this.manufacturer = manufacturer;
    }

    public void setProductType( ProductType type ) throws ZooException{
        if( type == null ) throw new ZooException("Empty Product Type");
        this.type = type;
    }

    public String getName(){
        return name;
    }

    public int getDescription(){
        return description;
    }

    public Manufacturer getManufacturer( Manufacturer manufacturer ){
        return manufacturer;
    }

    public ProductType getProductType(){
        return type;
    }

    public boolean matches( ProductSpec other ){
        return name == other.name && description == other.description
                && manufacturer == other.manufacturer && type == other.type;
    }

    public String toString()
    {
        StringBuffer buffer = new StringBuffer();
        buffer.append( "Product Name: " );
        buffer.append( name );
        buffer.append( "\nDescription:  " );
        buffer.append( description );
        buffer.append( "\nManufacturer: " );
        buffer.append( manufacturer.toString() );
        buffer.append( "\nProduct type: " );
        buffer.append( type.toString() );
        buffer.append( "\n" );
        return buffer.toString();
    }

}
