
package zoomagazin;

import java.io.Serializable;


public class User implements Serializable {
    private String username;
    private String password;
    private int type;

    public User( String username, String password, int vip ) throws ZooException{
        setUsername( username );
        setPassword( password );
        setVipStatus( vip );
    }

    public void setUsername( String username ) throws ZooException{
        if( username == null || username.equals("") ) throw new ZooException("Empty Username");
        this.username = username;
    }

    public void setPassword( String password ) throws ZooException{
        if( password == null || password.equals("") ) throw new ZooException("Empty Password");
        this.password = password;
    }

    public void setVipStatus( int type ) throws ZooException{
		if( type < 0 || type > 2 ) throw new ZooException("Invalid User type");
        this.type = type;
    }

    public String getUsername(){
        return username;
    }

    public String getPassword(){
        return password;
    }

    public int getType(){
        return type;
    }

	public String getTypeAsString(){
		String strType = "";
		switch(type) {
			case 0: {strType = "Normal"; break;}
			case 1: {strType = "Vip"; break;}
			case 2: {strType = "Admin"; break;}
			default: strType = "";
		}
		return strType;
	}

    public String toString()
    {
        StringBuffer buffer = new StringBuffer();
        buffer.append( "============\n" );
        buffer.append( "Username:    " );
        buffer.append( username );
        buffer.append( "\nVip status:  " );
        buffer.append( getTypeAsString() );
        buffer.append( "\n============\n" );
        return buffer.toString();
    }

}
