
package zoomagazin;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class ZooMarket extends javax.swing.JFrame {
    private Catalogue catalogue;
	private UserManager usermanager;
    private String username;
    private int usertype;
	private javax.swing.JFrame adminFrame;

	private final String fileUsers = "users";
	private final String fileProducts = "products";


    /** Creates new form ZooMarket */
    public ZooMarket() {
        initComponents();
        usermanager = new UserManager();
		catalogue = new Catalogue();
		adminFrame = new AdminArea();
		adminFrame.setDefaultCloseOperation(HIDE_ON_CLOSE);

		reloadDatabases();

		lstProducts.getSelectionModel().addListSelectionListener(new ListProductsListeneer());
		lstProducts.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		updateUserType(-1);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txtUsername = new javax.swing.JTextField();
        txtPassword = new javax.swing.JPasswordField();
        btnLogIn = new javax.swing.JButton();
        btnRegister = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstProducts = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtProductDesc = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        txtProductReviews = new javax.swing.JTextArea();
        jScrollPane4 = new javax.swing.JScrollPane();
        txtNewReview = new javax.swing.JTextArea();
        btnAddReview = new javax.swing.JButton();
        lblUsername = new javax.swing.JLabel();
        lblPassword = new javax.swing.JLabel();
        btnAdminArea = new javax.swing.JButton();
        btnRefreshProducts = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        btnLogIn.setText("Log in");
        btnLogIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLogInActionPerformed(evt);
            }
        });

        btnRegister.setText("Register");
        btnRegister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRegisterActionPerformed(evt);
            }
        });

        jScrollPane1.setViewportView(lstProducts);

        txtProductDesc.setColumns(20);
        txtProductDesc.setRows(5);
        jScrollPane2.setViewportView(txtProductDesc);

        txtProductReviews.setColumns(20);
        txtProductReviews.setRows(5);
        jScrollPane3.setViewportView(txtProductReviews);

        txtNewReview.setColumns(20);
        txtNewReview.setRows(5);
        jScrollPane4.setViewportView(txtNewReview);

        btnAddReview.setText("Add");
        btnAddReview.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddReviewActionPerformed(evt);
            }
        });

        lblUsername.setText("Username:");

        lblPassword.setText("Password:");

        btnAdminArea.setText("Edit database");
        btnAdminArea.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAdminAreaActionPerformed(evt);
            }
        });

        btnRefreshProducts.setText("Refresh");
        btnRefreshProducts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRefreshProductsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnAdminArea, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnRefreshProducts, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 236, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 39, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtUsername, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblUsername))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 74, Short.MAX_VALUE)
                                .addComponent(btnLogIn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnRegister))
                            .addComponent(lblPassword)))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 502, Short.MAX_VALUE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 502, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 422, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnAddReview)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnRegister)
                            .addComponent(btnLogIn)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnAdminArea)
                            .addComponent(btnRefreshProducts)))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblUsername)
                            .addComponent(lblPassword))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(31, 31, 31)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnAddReview)
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 561, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnRegisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRegisterActionPerformed
        String strUsername = txtUsername.getText();
		String strPassword = new String(txtPassword.getPassword());

		if(usermanager == null) {
			JOptionPane.showMessageDialog( null, "Users repository has not been opened!\n",
				"Register new user failed", JOptionPane.WARNING_MESSAGE );
			return;
		}
		User user = usermanager.getUser(strUsername, strPassword);

		if( user != null ){
			JOptionPane.showMessageDialog( null, "Username '" + strUsername + "' and password already exist.\n",
				"Register new user failed", JOptionPane.WARNING_MESSAGE );
			return;
		}
		try {
			usermanager.insertUser(new User(strUsername, strPassword, 0));
		} catch (ZooException ex) {
			JOptionPane.showMessageDialog( null, ex.getMessage(),
				"Register new user failed", JOptionPane.WARNING_MESSAGE );
			return;
		}
		try {
			usermanager.saveDataBase(fileUsers);
		} catch (ZooException ex) {
			JOptionPane.showMessageDialog( null, "Users database was not saved!\n" + ex.getMessage(),
				"Register new user failed", JOptionPane.WARNING_MESSAGE );
			return;
		}

		login(strUsername, strPassword);
}//GEN-LAST:event_btnRegisterActionPerformed

	private void btnLogInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLogInActionPerformed
		if( username == null ){
			String strUsername = txtUsername.getText();
			String strPassword = new String(txtPassword.getPassword());
			login(strUsername, strPassword);
		}
		else{
			username = null;
			updateUserType(-1);
			btnLogIn.setText("Log in");
		}
	}//GEN-LAST:event_btnLogInActionPerformed

	private void btnAddReviewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddReviewActionPerformed
		int index = lstProducts.getSelectionModel().getLeadSelectionIndex();
		if( index < 0 ) return;
		try {
			catalogue.getProduct(index).addReview(username, txtNewReview.getText());
			txtNewReview.setText("");
			printSelectedProduct();
		} catch (ZooException ex) {
			JOptionPane.showMessageDialog( null, "Failed to add this review!\n" + ex.getMessage(),
				"Adding review failed", JOptionPane.WARNING_MESSAGE );
			return;
		}
		try {
			catalogue.saveDataBase(fileProducts);
		} catch (ZooException ex) {
			JOptionPane.showMessageDialog( null, "Failed to save products database!\n" + ex.getMessage(),
				"Adding review failed", JOptionPane.WARNING_MESSAGE );
			return;
		}
	}//GEN-LAST:event_btnAddReviewActionPerformed

	private void btnAdminAreaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAdminAreaActionPerformed
		adminFrame.setVisible(true);
}//GEN-LAST:event_btnAdminAreaActionPerformed

	private void btnRefreshProductsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRefreshProductsActionPerformed
		reloadDatabases();
	}//GEN-LAST:event_btnRefreshProductsActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
				new ZooMarket().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddReview;
    private javax.swing.JButton btnAdminArea;
    private javax.swing.JButton btnLogIn;
    private javax.swing.JButton btnRefreshProducts;
    private javax.swing.JButton btnRegister;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JLabel lblPassword;
    private javax.swing.JLabel lblUsername;
    private javax.swing.JList lstProducts;
    private javax.swing.JTextArea txtNewReview;
    private javax.swing.JPasswordField txtPassword;
    private javax.swing.JTextArea txtProductDesc;
    private javax.swing.JTextArea txtProductReviews;
    private javax.swing.JTextField txtUsername;
    // End of variables declaration//GEN-END:variables


	class ListProductsListeneer implements ListSelectionListener {
		public void valueChanged(ListSelectionEvent e) {
			printSelectedProduct();
		}
	}

	private void login(String strUsername, String strPassword){
		if(usermanager == null) {
			JOptionPane.showMessageDialog( null, "Users repository has not been opened!",
				"Log in failed", JOptionPane.WARNING_MESSAGE );
		}
		User user = usermanager.getUser(strUsername, strPassword);
		if( user == null ) {
			JOptionPane.showMessageDialog( null, "Username '" + strUsername + "' and password "+strPassword+" don't exist.",
				"Log in failed", JOptionPane.WARNING_MESSAGE );
			return;
		}
		username = user.getUsername();
		updateUserType(user.getType());
		btnLogIn.setText("Log out " + username);

		txtUsername.setText("");
		txtPassword.setText("");
	}

	private void reloadDatabases(){
        try{
            usermanager.openDataBase(fileUsers);
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "User repository was not opened. Repo file = '" + fileUsers + "'. ", "Error repo open" );
			return;
        }

        try{
			catalogue.openDataBase(fileProducts);
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "Products repository was not opened. Repo file = '" + fileProducts + "'. ", "Error repo open" );
			return;
        }

		lstProducts.setListData(catalogue.getListProductNames());
	}

	private void updateUserType( int usertype ){
		this.usertype = usertype;
		boolean enabled = (usertype != -1);
		txtNewReview.setEditable(enabled);
		btnAddReview.setEnabled(enabled);
		btnAdminArea.setEnabled((usertype == 2));
	}
	
	private void printSelectedProduct(){
		int index = lstProducts.getLeadSelectionIndex();
		Product prod;
		try {
			prod = catalogue.getProduct(index);
			txtProductDesc.setText( prod.getProductDescription() );
			txtProductReviews.setText( prod.getProductReviews() );
		} catch (ZooException ex) {
			return;
		}
	}

    private static void logError( Exception ex, String reason, String title ){
        ex.printStackTrace();
        System.out.println();
        JOptionPane.showMessageDialog( null, reason + ex.getMessage(),
                title, JOptionPane.WARNING_MESSAGE );
    }
}
